SystemOrganization addCategory: #'CTM-Core'!
SystemOrganization addCategory: #'CTM-Example'!

Object subclass: #CTMEventListener
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMEventListener class
	instanceVariableNames: 'instance'!

CTMEventListener class
	instanceVariableNames: 'instance'!

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 20:35'!
instance

	^ instance ifNil: [ instance := self new ]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/23/2010 10:00'!
actions

	^ actions ifNil: [ actions := OrderedCollection new ]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:37'!
event: anEvent

	(anEvent itemKind == #method) ifTrue: [ self methodEvent: anEvent ].! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:24'!
methodEvent: anEvent

	| pragmas |
	pragmas := anEvent item pragmas.
	pragmas do: [ :pragma |
		CTMThing allSubclassesDo: [:class | | instance |
			instance := class new.
			(instance matchMethodPragma: pragma) ifTrue: [instance handleMethodEvent: anEvent]]].
	

! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:12'!
register

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:13'!
unregister

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #CTMMethodManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:42'!
addGeneratedMethodFor: aCompiledMethod with: aCodeString

	| class selector generatedMethods |
	class := aCompiledMethod methodClass.
	selector := self addMethodTo: class in: #generated with: aCodeString.
	
	generatedMethods := aCompiledMethod penultimateLiteral at: #cmtGenerated ifAbsent: [OrderedCollection new].
	(generatedMethods contains: [:i | i = selector]) ifFalse: [generatedMethods add: selector].
	aCompiledMethod penultimateLiteral at: #cmtGenerated put: generatedMethods.! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:41'!
addMethodTo: aClass in: aCategorySymbol with: aCodeString

	| |
	^ aClass compile: aCodeString classified: aCategorySymbol.! !

Object subclass: #CTMThing
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMThing subclass: #CTMShortcutsThing
	instanceVariableNames: 'shortcutName shortcutMaxCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMShortcutsThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:50'!
matchMethodPragma: aPragma

	(aPragma keyword = #shortcuts:count:) ifTrue: [
		shortcutName := aPragma argumentAt: 1.
		shortcutMaxCount := aPragma argumentAt: 2.
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMShortcutsThing methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:39'!
methodAdded: aMethod in: aClass
	
	| methodName collectionCreation |
	methodName := ''.
	collectionCreation := 'array := OrderedCollection new'.
	
	1 to: shortcutMaxCount do: [ :i | | code |
		methodName := '{1} {2}: aValue{3}' format: {methodName. shortcutName. i. }.
		collectionCreation := '{1} add: aValue{2}; ' format: {collectionCreation. i.}.
		
		code := '{1}
| array |
{2}yourself.
^ self {3} array' format: {methodName. collectionCreation. aMethod selector. }.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

!CTMThing class methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:59'!
convertModifiedToAddedRemoved

	^ true! !

!CTMThing methodsFor: 'internal' stamp: 'SR 1/6/2011 21:57'!
handleMethodEvent: anEvent

	| class method |
	method := anEvent item.
	class := anEvent environmentAt: #class.

	anEvent isAdded ifTrue: [ ^ self methodAdded: method in: class ].
	anEvent isModified ifTrue: [ ^ self methodModified: method in: class from: (anEvent oldItem) ].
	anEvent isRemoved ifTrue: [ ^ self methodRemoved: method in: class ].! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 22:03'!
matchClassPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:25'!
matchMethodPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:32'!
methodAdded: aMethod in: aClass
! !

!CTMThing methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:03'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new].! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 22:00'!
methodModified: aMethod in: aClass from: anOldMethod

	self class convertModifiedToAddedRemoved ifTrue: [
		self methodRemoved: anOldMethod in: aClass.
		self methodAdded: aMethod in: aClass]! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:38'!
methodRemoved: aMethod in: aClass! !

Object subclass: #Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Example'!

!Test methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:41'!
micha: anArray

	<shortcuts: #michas count: 2>
	anArray inspect.! !

!Test methodsFor: 'generated' stamp: 'SR 1/6/2011 22:41'!
michas: aValue1
| array |
array := OrderedCollection new add: aValue1; yourself.
^ self micha: array! !

!Test methodsFor: 'generated' stamp: 'SR 1/6/2011 22:42'!
michas: aValue1 michas: aValue2
| array |
array := OrderedCollection new add: aValue1;  add: aValue2; yourself.
^ self micha: array! !
